/*
 *   ORXONOX - the hottest 3D action shooter ever to exist
 *                    > www.orxonox.net <
 *
 *
 *   License notice:
 *
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public License
 *   as published by the Free Software Foundation; either version 2
 *   of the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 *
 *   Author:
 *      Fabian 'x3n' Landau
 *   Co-authors:
 *      Dominik Solenicki
 *
 */

#include "WingmanController.h"


namespace orxonox
{

    RegisterClass(WingmanController);
    

    WingmanController::WingmanController(Context* context) : CommonController(context)
    {
        RegisterObject(WingmanController);
        this->actionTimer_.setTimer(ACTION_INTERVAL, true, createExecutor(createFunctor(&WingmanController::action, this)));
        this->myLeader_ = 0;
        this->rank_ = Rank::WINGMAN;

    }

    WingmanController::~WingmanController()
    {

    }
    // void WingmanController::chooseManeuver()
    // {
    //     if (this->maneuverType_ == ManeuverType::NONE)
    //     switch (this->maneuverType_ )
    //     {
    //         case ManeuverType::NONE:
    //         {

    //             break;
    //         }
    //         case ManeuverType::NEUTRAL:
    //         {

    //             break;
    //         }
    //         case ManeuverType::OFFENSIVE:
    //         {

    //             break;
    //         }
    //         case ManeuverType::DEFENSIVE:
    //         {

    //             break;
    //         }
    //     }
    //     if (!this->myWingman_)
    //         return;
    //     Vector3* targetRelativePositionOfWingman;
    //     switch (this->formationMode_){
    //         case FormationMode::WALL:
    //         {
    //             targetRelativePositionOfWingman = new Vector3 (-400, 0, 0);  
    //             break;
    //         }
    //         case FormationMode::FINGER4: 
    //         {
    //             targetRelativePositionOfWingman = new Vector3 (-400, 0, -200);  
    //             break;
    //         }
    //         case FormationMode::VEE: 
    //         {
    //             break;
    //         }
    //         case FormationMode::DIAMOND: 
    //         {
    //             targetRelativePositionOfWingman = new Vector3 (400, -200, 0);                  
    //             break;
    //         }
    //     }
    //     Quaternion orient = this->getControllableEntity()->getWorldOrientation();
        
    //     Vector3 targetAbsolutePositionOfWingman = ((this->getControllableEntity()->getWorldPosition()) + 
    //     (this->getControllableEntity()->getWorldOrientation()* (*targetRelativePositionOfWingman)));
        
    //     myWingman_->setTargetOrientation(orient);
    //     myWingman_->setTargetPosition(targetAbsolutePositionOfWingman);
       
    // }

    void WingmanController::tick(float dt)
    {   
       
        
        if (!this->isActive())
            return;
        if (!this->target_)
        {
            //stay in formation
        }
        else
        {

        }
        if (this->bHasTargetPosition_)
        {
            this->moveToTargetPosition(dt);
        } 
        
        if (this->bShooting_)
            doFire();
        
        SUPER(WingmanController, tick, dt);
    }
    
    void WingmanController::action()
    {
        if (!this->myLeader_)
        {
            CommonController* newLeader = findNewLeader();
            this->myLeader_ = newLeader;
            if (newLeader)
                orxout(internal_error) << "new Leader set" << endl;
            else
            {
                //orxout(internal_error) << "0 leader" << endl;
                
            }

        }
        else
        {

        }
        if (canFire())
           this->bShooting_ = true;
        else
            this->bShooting_ = false;
          
    }
     
   
    

    CommonController* WingmanController::findNewLeader()
    {

        if (!this->getControllableEntity())
            return 0;

        CommonController* closestLeader = 0;
        float minDistance =  std::numeric_limits<float>::infinity();

        for (ObjectList<CommonController>::iterator it = ObjectList<CommonController>::begin(); it; ++it)
        {
            //0ptr?
            if (!it || 
                (it->getRank() != Rank::SECTIONLEADER && it->getRank() != Rank::DIVISIONLEADER) || 
                !(it->getControllableEntity()))
                continue;
            //same team?
            if (this->getControllableEntity()->getTeam() != (it)->getControllableEntity()->getTeam())
                continue;
            //is equal to this?
            if (it->getControllableEntity() == this->getControllableEntity())
                continue;

            float distance = (it->getControllableEntity()->getPosition() - this->getControllableEntity()->getPosition()).length();
            if (distance < minDistance && !(it->hasWingman()))
            {
                closestLeader = *it;
                minDistance = distance;
            }
           
        }
        if (closestLeader)
        {
            if (closestLeader->setWingman(this))
                return closestLeader;
        }
        return 0;
    }

    void WingmanController::XMLPort(Element& xmlelement, XMLPort::Mode mode)
    {
        SUPER(WingmanController, XMLPort, xmlelement, mode);

        //XMLPortParam(SectionController, "target_", setTarget, getTarget, xmlelement, mode).defaultValues(100.0f);
    }



}
